Attribute VB_Name = "NESHardware"
'+====================================================+'
'| basicNES 2k                                        |'
'| by Don Jarrett, 2000                               |'
'| Big portions of graphics code done by David Finch. |'
'| Always a source/binary release                     |'
'| http://home.att.net/~r.jarrett/bNES.html           |'
'+====================================================+'

Option Explicit ' Option Explicit is important for avoiding mysterious, crippling bugs


DefLng A-Z 'this ensures that no variants are used unless we choose so

    Public p16(31) As Integer
    Public p32(31) As Long
'Public EmphVal As Integer


Public PALFile(&HBF) As Byte
Public romName As String
Public ClippingLatch As Boolean

Public ZoomSize As Integer
Public tmpLatch As Byte, ppuLatch As Byte

Public map24_irqv As Byte

Public Interlace As Long

Public MirrorTypes(4) As String

'DF: array to draw each frame to
Public vBuffer(256& * 241& - 1) As Byte '256*241 to allow for some overflow

Public nt(0 To 3, &H0 To &H3FF) As Byte
Public mirror(3) As Byte

Public vBuffer16(256& * 240& - 1) As Integer
Public vBuffer32(256& * 240& - 1) As Long

Public oldvBuffer16(256& * 240& - 1) As Integer 'used for scaling modes that take advantage of unchanged pixels

Public vBuffer2x16(512& * 480& - 1) As Integer
Public vBuffer2x32(512& * 480& - 1) As Long

Public tLook(65536 * 8 - 1) As Byte

Public SpritesChanged As Boolean

Public Record As Boolean
Public MovieIndex As Integer
Public Playing As Boolean

Public map17_irqon As Boolean
Public map17_irq As Long

Public IRQCounter As Long ' for mapper 6
Public map6_irqon As Byte
Public map225_psize As Byte
Public map225_psel As Byte
Public Train(&H1FF) As Byte
Public latch13 As Byte
Public MMC19_IRQCount As Long
Public MIRQOn As Byte
Public map24_irqon As Byte


'DF: powers of 2
Public pow2(31) As Long

' NES Hardware defines
Public PPU_Control1 As Byte ' $2000
Public PPU_Control2 As Byte ' $2001
Public PPU_Status As Byte ' $2002
Public SpriteAddress As Long ' $2003
Public PPUAddressHi As Long ' $2006, 1st write
Public PPUAddress As Long ' $2006
Public PPU_AddressIsHi As Boolean
Public VRAM(&H3FFF) As Byte, VROM() As Byte  ' Video RAM
Public SpriteRAM(&HFF) As Byte

Public Sound(0 To &H15) As Byte
Public SoundCtrl As Byte

Public VScroll2 As Long

Public PrgCount As Byte, PrgCount2 As Long, ChrCount As Byte, ChrCount2 As Long

Public cmd As Byte, prg As Byte, chr1 As Byte

Public reg8 As Byte
Public regA As Byte
Public regC As Byte
Public regE As Byte

Public NESPal(&HF) As Byte

Public CPal() As Long

Public FrameSkip As Long 'Integer
Public Frames As Long

Public ScrollToggle As Byte
Public HScroll As Byte, VScroll As Long 'Integer ' $2005

Public Map15_BankAddr As Byte
Public Map15_SwapReg As Byte

'DF: these variables were undefined and therefore local:
Public swap As Boolean
Public map15_swapaddr As Long

' MMC3[Mapper #4] infos
Public MMC3_Command As Byte
Public MMC3_PrgAddr As Byte
Public MMC3_ChrAddr As Integer
Public MMC3_IrqVal As Byte
Public MMC3_TmpVal As Byte
Public MMC3_IrqOn As Boolean

Public PatternTable As Long
Public NameTable As Long

Public bank_regs(16) As Byte

Public Const PPU_InVBlank = &H80
Public Const PPU_Sprite0 = &H40
Public Const PPU_SpriteCount = &H20
Public Const PPU_Ignored = &H10

Public reg8000 As Byte ' Needed for mapper #69.

Public AndIt As Byte, AndIt2 As Byte

Public data(4) As Byte, sequence As Long 'Integer
Public accumulator As Long 'Integer

Public render As Boolean

Public MotionBlur As Boolean
Public Smooth2x As Long

Public Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    Flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type
Public OpenFile As OPENFILENAME

Public ChrCnt As Byte, PrgCnt As Byte
Public FirstRead As Boolean ' First read to $2007 is invalid
Public Joypad1(7) As Byte, Joypad1_Count As Byte
Public Joypad2(7) As Byte, Joypad2_Count As Byte

Public Mapper As Byte, Mirroring As Byte, Trainer As Byte, FourScreen As Byte
Public MirrorXor As Long 'Integer
Public UsesSRAM As Boolean

Public Keyboard(255) As Byte

Public CPURunning As Boolean

Public Declare Sub MemCopy Lib "kernel32" Alias "RtlMoveMemory" (dest As Any, src As Any, ByVal cb&)

Public Declare Sub MemFill Lib "kernel32" Alias "RtlFillMemory" (Destination As Any, ByVal Length As Long, ByVal Fill As Byte)


Public MMC32_Switch As Byte

Public MMC16_Irq As Long 'Integer
Public MMC16_IrqOn As Byte

Public PPUAddress2 As Long
Public HScroll2 As Long

'outdated code
Public Type Sprite
    x As Integer
    Y As Integer
    tileno As Byte
    attrib As Byte
End Type
Public SpriteAddr As Long 'Integer

Public pal(255) As Long
Public pal16(255) As Integer
Public pal15(255) As Integer

'Public Sprites(63) As Sprite

Public noScroll2006 As Boolean

Public Mapper40_IRQEnabled As Byte, Mapper40_IRQCounter As Byte

Public latch1 As Byte, latch2 As Byte
Public Latch0FD As Byte, Latch0FE As Byte
Public Latch1FD As Byte, Latch1FE As Byte

Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long


'Fills color lookup table
Public Sub fillTLook()
    Dim b1, b2, c, x
    For b1 = 0 To 255
    For b2 = 0 To 255
        For x = 0 To 7
            If b1 And pow2(x) Then c = 1 Else c = 0
            If b2 And pow2(x) Then c = c + 2
            tLook(b1 * 2048 + b2 * 8 + x) = c
        Next x
    Next b2, b1
End Sub

Public Sub blitScreen()
    Static mbt As Boolean
    Static n As Long
    mbt = Not mbt
    n = 1 - n
    Static count64 As Long
    count64 = (count64 + 17) And 63
    
    Dim fscan As Boolean
    
    Dim t As Long
        
    
    Dim p01 As Integer, p10 As Integer, p21 As Integer, p12 As Integer
    
    Dim p01b As Long, p10b As Long, p21b As Long, p12b As Long
    
    'Involves converting to high or true color.
    'Could be sped up if you took time to figure out palette animation in windows.
    Dim x, Y, k, b, c
    
    Dim i As Long
    Static colordepth
    If colordepth = 0 Or (Frames And 63) = 0 Then colordepth = getColorDepth(frmNES.picScreen)
    Select Case colordepth
    Case 8
        'first change the bitmap palette
            'not sure how
            
        'then blit
        'blit8 vBuffer, frmNES.picScreen, 256, 240
    Case 16
        If MotionBlur Then
            For i = 0 To 31
                p16(i) = (pal16(VRAM(i + &H3F00)) And &HF7DE&) \ 2
            Next i
            If mbt Then
                For i = 0 To 61439
                    vBuffer16(i) = (vBuffer16(i) And &HF7DE&) \ 2 + p16(vBuffer(i)) + &H20
                Next i
            Else
                For i = 0 To 61439
                    vBuffer16(i) = (vBuffer16(i) And &HF7DE&) \ 2 + p16(vBuffer(i)) + &H801
                Next i
            End If
            
        Else
            For i = 0 To 31
                p16(i) = pal16(VRAM(i + &H3F00))
            Next i
            For i = 0 To 61439 Step 4
                vBuffer16(i) = p16(vBuffer(i))
                vBuffer16(i + 1) = p16(vBuffer(i + 1))
                vBuffer16(i + 2) = p16(vBuffer(i + 2))
                vBuffer16(i + 3) = p16(vBuffer(i + 3))
            Next i
        End If
        
        Call ppuleftclip(colordepth)  'awetAWETAWE

        If Smooth2x Then
            If Smooth2x = 1 Then
                For Y = 0 To 239
                i = Y * 256&
                k = Y * 1024&
                c = 0
                For x = 0 To 255
                    b = vBuffer16(i)
                    vBuffer2x16(k + 1) = b
                    b = (b And &HF7DE&) \ 2
                    vBuffer2x16(k) = b + c
                    c = b
                    i = i + 1
                    k = k + 2
                Next x, Y
                For Y = 0 To 238
                k = Y * 1024 + 512
                For x = 0 To 511
                    vBuffer2x16(k) = (vBuffer2x16(k - 512) And &HF7DE&) \ 2 + (vBuffer2x16(k + 512) And &HF7DE&) \ 2
                    k = k + 1
                Next x, Y
            Else
                For Y = 1 To 238
                i = Y * 256&
                k = Y * 1024&
                c = vBuffer16(i - 1)
                p21 = vBuffer16(i)
                fscan = (Y And 63) = count64
                For x = IIf(x > 1, 0, 1) To 255
                    b = vBuffer16(i + 1)
                    If b <> oldvBuffer16(i + 1) Then
                        If t <= 0 Then
                            c = vBuffer16(i - 1)
                            p21 = vBuffer16(i)
                        End If
                        t = 3
                    End If
                    If t > 0 Or fscan Then
                        t = t - 1
                        p01 = c
                        c = p21
                        p21 = b
                        b = (c And &HF7DE&) \ 2
                        p10 = vBuffer16(i - 256)
                        p12 = vBuffer16(i + 256)
                        If p01 = p10 And p12 = p21 Then
                            If p10 = p12 And vBuffer16(i - 257) = c Then
                                vBuffer2x16(k) = c
                                vBuffer2x16(k + 1) = (p10 And &HF7DE&) \ 2 + b
                                vBuffer2x16(k + 512) = (p12 And &HF7DE&) \ 2 + b
                                vBuffer2x16(k + 513) = c
                            Else
                                vBuffer2x16(k) = (p01 And &HF7DE&) \ 2 + b
                                vBuffer2x16(k + 1) = c
                                vBuffer2x16(k + 512) = c
                                vBuffer2x16(k + 513) = (p21 And &HF7DE&) \ 2 + b
                            End If
                        ElseIf p10 = p21 And p01 = p12 Then
                            vBuffer2x16(k) = c
                            vBuffer2x16(k + 1) = (p10 And &HF7DE&) \ 2 + b
                            vBuffer2x16(k + 512) = (p12 And &HF7DE&) \ 2 + b
                            vBuffer2x16(k + 513) = c
                        Else
                            vBuffer2x16(k) = c
                            vBuffer2x16(k + 1) = c
                            vBuffer2x16(k + 512) = c
                            vBuffer2x16(k + 513) = c
                        End If
                    End If
                    i = i + 1
                    k = k + 2
                Next x, Y
                MemCopy oldvBuffer16(0), vBuffer16(0), 122880
            End If
            
            
            blit16 vBuffer2x16, frmNES.picScreen, 512, 480
        Else
            blit16 vBuffer16, frmNES.picScreen, 256, 240
        End If
    Case 15
        If MotionBlur Then
            For i = 0 To 31
                p16(i) = (pal15(VRAM(i + &H3F00)) And &H7BDE&) \ 2
            Next i
            If mbt Then
                For i = 0 To 61439
                    vBuffer16(i) = (vBuffer16(i) And &H7BDE&) \ 2 + p16(vBuffer(i)) + &H20
                Next i
            Else
                For i = 0 To 61439
                    vBuffer16(i) = (vBuffer16(i) And &H7BDE&) \ 2 + p16(vBuffer(i)) + &H401
                Next i
            End If
        Else
            For i = 0 To 31
                p16(i) = pal15(VRAM(i + &H3F00))
            Next i
            For i = 0 To 61439 Step 4
                vBuffer16(i) = p16(vBuffer(i))
                vBuffer16(i + 1) = p16(vBuffer(i + 1))
                vBuffer16(i + 2) = p16(vBuffer(i + 2))
                vBuffer16(i + 3) = p16(vBuffer(i + 3))
            Next i
        End If
        
        Call ppuleftclip(colordepth)  'awetAWETAWE
        If Smooth2x Then
            If Smooth2x = 1 Then
                For Y = 0 To 239
                i = Y * 256&
                k = Y * 1024&
                c = 0
                For x = 0 To 255
                    b = vBuffer16(i)
                    vBuffer2x16(k + 1) = b
                    b = (b And &H7BDE&) \ 2
                    vBuffer2x16(k) = b + c
                    c = b
                    i = i + 1
                    k = k + 2
                Next x, Y
                For Y = 0 To 238
                k = Y * 1024 + 512
                For x = 0 To 511
                    vBuffer2x16(k) = (vBuffer2x16(k - 512) And &H7BDE&) \ 2 + (vBuffer2x16(k + 512) And &H7BDE&) \ 2
                    k = k + 1
                Next x, Y
            Else
                For Y = 1 To 238
                i = Y * 256&
                k = Y * 1024&
                c = vBuffer16(i - 1)
                p21 = vBuffer16(i)
                fscan = (Y And 63) = count64
                For x = IIf(x > 1, 0, 1) To 255
                    If vBuffer16(i + 2) <> oldvBuffer16(i + 2) Then
                        If t <= 0 Then
                            c = vBuffer16(i - 1)
                            p21 = vBuffer16(i)
                        End If
                        t = 5
                    End If
                    If t > 0 Or fscan Then
                        t = t - 1
                        p01 = c
                        c = p21
                        p21 = vBuffer16(i + 1)
                        b = (c And &H7BDE&) \ 2
                        p10 = vBuffer16(i - 256)
                        p12 = vBuffer16(i + 256)
                        If p01 = p10 And p12 = p21 Then
                            If p10 = p12 And vBuffer16(i - 257) = c Then
                                vBuffer2x16(k) = c
                                vBuffer2x16(k + 1) = (p10 And &H7BDE&) \ 2 + b
                                vBuffer2x16(k + 512) = (p12 And &H7BDE&) \ 2 + b
                                vBuffer2x16(k + 513) = c
                            Else
                                vBuffer2x16(k) = (p01 And &H7BDE&) \ 2 + b
                                vBuffer2x16(k + 1) = c
                                vBuffer2x16(k + 512) = c
                                vBuffer2x16(k + 513) = (p21 And &H7BDE&) \ 2 + b
                            End If
                        ElseIf p10 = p21 And p01 = p12 Then
                            vBuffer2x16(k) = c
                            vBuffer2x16(k + 1) = (p10 And &H7BDE&) \ 2 + b
                            vBuffer2x16(k + 512) = (p12 And &H7BDE&) \ 2 + b
                            vBuffer2x16(k + 513) = c
                        Else
                            vBuffer2x16(k) = c
                            vBuffer2x16(k + 1) = c
                            vBuffer2x16(k + 512) = c
                            vBuffer2x16(k + 513) = c
                        End If
                    End If
                    i = i + 1
                    k = k + 2
                Next x, Y
                MemCopy oldvBuffer16(0), vBuffer16(0), 122880
            End If
            blit15 vBuffer2x16, frmNES.picScreen, 512, 480
        Else
            blit15 vBuffer16, frmNES.picScreen, 256, 240
        End If
    Case Else
        If MotionBlur Then
            For i = 0 To 31
                p32(i) = (pal(VRAM(i + &H3F00)) And &HFEFEFE) \ 2
            Next i
            For i = 0 To 61439
                vBuffer32(i) = (vBuffer32(i) And &HFEFEFE) \ 2 + p32(vBuffer(i))
            Next i
        Else
            For i = 0 To 31
                p32(i) = pal(VRAM(i + &H3F00))
            Next i
            For i = 0 To 61439 Step 4
                vBuffer32(i) = p32(vBuffer(i))
                vBuffer32(i + 1) = p32(vBuffer(i + 1))
                vBuffer32(i + 2) = p32(vBuffer(i + 2))
                vBuffer32(i + 3) = p32(vBuffer(i + 3))
            Next i
        End If
        Call ppuleftclip(colordepth)  'awetAWETAWE
    
        If Smooth2x Then
            If Smooth2x = 1 Then
                For Y = 0 To 239
                i = Y * 256&
                k = Y * 1024&
                c = 0
                For x = 0 To 255
                    b = vBuffer32(i)
                    vBuffer2x32(k + 1) = b
                    b = (b And &HFEFEFE) \ 2
                    vBuffer2x32(k) = b + c
                    c = b
                    i = i + 1
                    k = k + 2
                Next x, Y
                For Y = 0 To 238
                k = Y * 1024 + 512
                For x = 0 To 511
                    vBuffer2x32(k) = (vBuffer2x32(k - 512) And &HFEFEFE) \ 2 + (vBuffer2x32(k + 512) And &HFEFEFE) \ 2
                    k = k + 1
                Next x, Y
            Else
                t = n
                For Y = 1 To 238
                i = Y * 256&
                k = Y * 1024&
                c = vBuffer32(i - 1)
                p21b = vBuffer32(i)
                t = 1 - t
                For x = IIf(x > 1, 0, 1) To 255
                    t = 1 - t
                    p01b = c
                    c = p21b
                    p21b = vBuffer32(i + 1)
                    If t Or c <> vBuffer2x32(k) Then
                        b = (c And &HFEFEFE) \ 2
                        p10b = vBuffer32(i - 256)
                        p12b = vBuffer32(i + 256)
                        If p01b = p10b And p12b = p21b Then
                            If p10b = p12b And vBuffer32(i - 257) = c Then
                                vBuffer2x32(k) = c
                                vBuffer2x32(k + 1) = (p10b And &HFEFEFE) \ 2 + b
                                vBuffer2x32(k + 512) = (p12b And &HFEFEFE) \ 2 + b
                                vBuffer2x32(k + 513) = c
                            Else
                                vBuffer2x32(k) = (p01b And &HFEFEFE) \ 2 + b
                                vBuffer2x32(k + 1) = c
                                vBuffer2x32(k + 512) = c
                                vBuffer2x32(k + 513) = (p21b And &HFEFEFE) \ 2 + b
                            End If
                        ElseIf p10b = p21b And p01b = p12b Then
                            vBuffer2x32(k) = c
                            vBuffer2x32(k + 1) = (p10b And &HFEFEFE) \ 2 + b
                            vBuffer2x32(k + 512) = (p12b And &HFEFEFE) \ 2 + b
                            vBuffer2x32(k + 513) = c
                        Else
                            vBuffer2x32(k) = c
                            vBuffer2x32(k + 1) = c
                            vBuffer2x32(k + 512) = c
                            vBuffer2x32(k + 513) = c
                        End If
                    End If
                    i = i + 1
                    k = k + 2
                Next x, Y
            End If
            
            
            Blit vBuffer2x32, frmNES.picScreen, 512, 480
        Else
            Blit vBuffer32, frmNES.picScreen, 256, 240
        End If
    End Select

End Sub



Public Sub RenderScanline(ByVal Scanline As Long)
domirror ' set the mirroring
'scanline based sprite rendering
If Scanline > 239 Then Exit Sub

If Scanline = 0 Then
    If render Then MemFill vBuffer(0), 256& * 240&, 16

    'temporary measure until the mirroring problems can be fixed
    Static pm, pmx
    If MirrorXor <> pmx Then
        If MirrorXor = 0 Then
            Mirroring = 2
        ElseIf MirrorXor = &H400& Then
            Mirroring = 0
        ElseIf MirrorXor = 3333 Then
            Mirroring = 3
        Else
            Mirroring = 1
        End If
    ElseIf pm <> Mirroring Then
        If Mirroring = 0 And MirrorXor <> &H400& Then
                MirrorXor = &H400&
        ElseIf Mirroring = 1 And MirrorXor <> &H800& Then
                MirrorXor = &H800&
        ElseIf Mirroring = 2 And MirrorXor <> 0 Then
                MirrorXor = &H800&
        ElseIf Mirroring = 3 And MirrorXor <> 3333 Then
                MirrorXor = 3333
        End If
    End If
    pm = Mirroring
    pmx = MirrorXor
End If

  If ((PPU_Control2 And 2) = 0) Then 'left clipping
    'got rid of sprite clipping counting as bg clip -> Or ((PPU_Control2 And 4) = 0)
    ClippingLatch = True
  Else
    ClippingLatch = False
  End If

If (PPU_Control2 And 16) = 0 Or Not render Then
    If Scanline > SpriteRAM(0) + 8 Then PPU_Status = PPU_Status Or 64
    Exit Sub
End If

Dim v As Long
Dim nt2 As Byte
'still some bugs in Little Nemo, Kirby.
    If Scanline = 0 Then
        PPUAddress = PPUAddress2
    Else
        PPUAddress = (PPUAddress And &HFBE0&) Or (PPUAddress2 And &H41F&)
    End If
   
    NameTable = &H2000& + (PPUAddress And &HC00)
    nt2 = (NameTable And &HC00&) \ &H400&

    HScroll = (PPUAddress And 31) * 8 + HScroll2
    VScroll = (PPUAddress \ 32 And 31) * 8 Or ((PPUAddress \ &H1000&) And 7)
    
    'If PPUAddress And 8192 Then VScroll = VScroll + 240
    
    VScroll = VScroll - Scanline
    
    v = PPUAddress
    
    ' the following "if" and contents were ported from Nester
    If (v And &H7000&) = &H7000& Then '/* is subtile y offset == 7? */
        v = v And &H8FFF& '/* subtile y offset = 0 */
        If (v And &H3E0&) = &H3A0& Then '/* name_tab line == 29? */
            v = v Xor &H800&   '/* switch nametables (bit 11) */
            v = v And &HFC1F&  '/* name_tab line = 0 */
        Else
            If (v And &H3E0&) = &H3E0& Then  '/* line == 31? */
                v = v And &HFC1F&  '/* name_tab line = 0 */
            Else
                v = v + &H20&
            End If
        End If
    Else
        v = v + &H1000&
    End If
    
    PPUAddress = v And &HFFFF&


'If Scanline < 8 Then PPU_Status = PPU_Status And &H3F
If Scanline = 239 Then PPU_Status = PPU_Status Or &H80
If Not render Then 'speed optimization when drawing skipped frame
    If PPU_Status And &H40 Then Exit Sub
    If Scanline > SpriteRAM(0) + 8 Then PPU_Status = PPU_Status Or &H40
    Exit Sub
End If

'If Scanline < 50 Then HScroll = 127


'VScroll = Scanline + (Frames Mod 240)

Dim TileRow As Byte, TileYOffset As Long 'Integer
Dim TileCounter As Long 'Integer
Dim Color As Long
Dim TileIndex As Byte, Byte1 As Byte, Byte2 As Byte
Dim LookUp As Byte, addToCol As Long
Dim pixel As Long 'Integer
Dim x As Long, Aa As Long ', c As Long, pc As Long, px As Long
Dim m As Long
Dim sc As Long
Dim atrtab As Long
Static phs As Long, pvs As Long
Dim Y As Long





sc = Scanline + VScroll
'If newScr'oll And sc >= 240 Then sc = sc - 1 'quick fix for mysterious problem
If sc > 480 Then sc = sc - 480

'draw background
TileRow = (sc \ 8) Mod 30
TileYOffset = sc And 7

If TileYOffset = 0 Then
    pvs = VScroll
    phs = HScroll
End If


atrtab = &H3C0
PatternTable = (PPU_Control1 And &H10) * &H100&
For TileCounter = HScroll \ 8 To 31
    TileIndex = nt(mirror(nt2), TileCounter + TileRow * 32)
    'TileIndex = VRAM(NameTable + TileCounter + TileRow * 32)
    If Mapper = 9 Or Mapper = 10 Then
        If PatternTable = &H0 Then
            map9_latch TileIndex, False
        ElseIf PatternTable = &H1000& Then
            map9_latch TileIndex, True
        End If
    End If
    x = TileCounter * 8 - HScroll + 7
    If x < 7 Then m = x Else m = 7
    x = x + Scanline * 256&
    LookUp = nt(mirror(nt2), (&H3C0& + TileCounter \ 4 + (TileRow \ 4) * &H8&))
    Select Case (TileCounter And 2) Or (TileRow And 2) * 2
        Case 0
            addToCol = LookUp * 4 And 12
        Case 2
            addToCol = LookUp And 12
        Case 4
            addToCol = LookUp \ 4 And 12
        Case 6
            addToCol = LookUp \ 16 And 12
    End Select
        Byte1 = VRAM(PatternTable + TileIndex * 16 + TileYOffset)
        Byte2 = VRAM(PatternTable + TileIndex * 16 + 8 + TileYOffset)
        Aa = Byte1 * 2048& + Byte2 * 8
        For pixel = m To 0 Step -1
            Color = tLook(Aa + pixel)
            If Color Then vBuffer(x - pixel) = Color Or addToCol
        Next pixel
Next TileCounter

    'NameTable = &H2000 + (PPUAddress And &H800) Xor &H400
    NameTable = NameTable Xor &H400
    nt2 = (NameTable And &HC00&) \ &H400&
atrtab = &H3C0
For TileCounter = 0 To HScroll \ 8
    TileIndex = nt(mirror(nt2), TileCounter + TileRow * 32)
    'TileIndex = VRAM(NameTable + (TileCounter + TileRow * 32))
    If Mapper = 9 Or Mapper = 10 Then
        If PatternTable = &H0 Then
            map9_latch TileIndex, False
        ElseIf PatternTable = &H1000& Then
            map9_latch TileIndex, True
        End If
    End If
    x = TileCounter * 8 + 256 - HScroll + 7
    If x > 255 Then m = x - 255 Else m = 0
    x = x + Scanline * 256&
    LookUp = nt(mirror(nt2), (&H3C0& + TileCounter \ 4 + (TileRow \ 4) * &H8&))
    Select Case (TileCounter And 2) Or (TileRow And 2) * 2
        Case 0
            addToCol = LookUp * 4 And 12
        Case 2
            addToCol = LookUp And 12
        Case 4
            addToCol = LookUp \ 4 And 12
        Case 6
            addToCol = LookUp \ 16 And 12
    End Select
        Byte1 = VRAM(PatternTable + (TileIndex * 16) + TileYOffset)
        Byte2 = VRAM(PatternTable + (TileIndex * 16) + 8 + TileYOffset)
        Aa = Byte1 * 2048& + Byte2 * 8
        For pixel = 7 To m Step -1
            Color = tLook(Aa + pixel)
            If Color Then vBuffer(x - pixel) = Color Or addToCol
        Next pixel
Next TileCounter

RenderSprites Scanline - 1 ', False
End Sub
Public Sub RenderSprites(ByVal Scanline As Long) ' , topLayer As Boolean)
Dim solid(264) As Boolean

If (PPU_Control2 And 16) = 0 Then Exit Sub

Dim TileRow As Byte, TileYOffset As Long 'Integer
Dim TileCounter As Long 'Integer
Dim Color As Byte
Dim TileIndex As Byte, Byte1 As Byte, Byte2 As Byte
Dim addToCol As Long
Dim h As Byte
Dim minX As Long
Dim X1 As Long, y1 As Long
Dim ptable As Long

TileRow = Scanline \ 8
TileYOffset = Scanline And 7
If PPU_Control1 And &H20 Then
    h = 16
Else
    h = 8
End If
If PPU_Control1 And &H8 Then
    If h = 8 Then
        PatternTable = &H1000&
    End If
Else
    If h = 8 Then
        PatternTable = &H0
    End If
End If
If PPU_Control2 And &H8 Then minX = 0 Else minX = 8
Dim spr As Long 'Integer
Dim SpriteAddr As Integer
Dim i As Long, x As Long, Aa As Long, v As Long
Dim ontop As Boolean
Dim attr As Byte
i = Scanline * 256&
For spr = 0 To 63 '63 To 0 Step -1
    SpriteAddr = 4 * spr
    y1 = SpriteRAM(SpriteAddr) + 1
    If y1 <= Scanline And y1 > Scanline - h Then
        attr = SpriteRAM(SpriteAddr + 2)
        ontop = (attr And 32) = 0
        'If (attr And 32) = 0 Xor topLayer Then
            X1 = SpriteRAM(SpriteAddr + 3)
            If X1 >= minX Then
                If render And X1 < 248 Then
                    addToCol = &H10 + (attr And 3) * 4
                    
                    TileIndex = SpriteRAM(SpriteAddr + 1)
                    If Mapper = 9 Or Mapper = 10 Then
                        If PatternTable = &H0 Then
                            map9_latch TileIndex, False
                        ElseIf PatternTable = &H1000& Then
                            map9_latch TileIndex, True
                        End If
                    End If
                    If h = 16 Then
                        If TileIndex And 1 Then
                            PatternTable = &H1000
                            TileIndex = TileIndex Xor 1
                        Else
                            PatternTable = 0
                        End If
                    End If
                    If attr And 128 Then 'vertical flip
                        v = y1 - Scanline - 1
                    Else
                        v = Scanline - y1
                    End If
                    v = v And h - 1
                    If v >= 8 Then v = v + 8
                    Byte1 = VRAM(PatternTable + (TileIndex * 16) + v)
                    Byte2 = VRAM(PatternTable + (TileIndex * 16) + 8 + v)
                    '#If 0 Then
                    'real sprite 0 detection
                    If spr = 0 And (PPU_Status And 64) = 0 Then
                        If attr And 64 Then 'horizontal flip
                            Aa = i + X1
                            For x = 0 To 7
                                If Byte1 And pow2(x) Then Color = 1 Else Color = 0
                                If Byte2 And pow2(x) Then Color = Color + 2
                                If Color Then
                                    'If Not solid(X1 + x) Then
                                        If vBuffer(Aa + x) And 3 And (PPU_Status And 64) = 0 Then
                                            PPU_Status = PPU_Status Or 64
                                            If ontop Then vBuffer(Aa + x) = addToCol Or Color
                                        Else
                                            vBuffer(Aa + x) = addToCol Or Color
                                        End If
                                        solid(X1 + x) = True
                                    'End If
                                End If
                            Next x
                        Else
                            Aa = i + X1 + 7
                            For x = 7 To 0 Step -1
                                If Byte1 And pow2(x) Then Color = 1 Else Color = 0
                                If Byte2 And pow2(x) Then Color = Color + 2
                                If Color Then
                                    'If Not solid(X1 + 7 - x) Then
                                        If vBuffer(Aa - x) And 3 And (PPU_Status And 64) = 0 Then
                                            PPU_Status = PPU_Status Or 64
                                            If ontop Then vBuffer(Aa - x) = addToCol Or Color
                                        Else
                                            vBuffer(Aa - x) = addToCol Or Color
                                        End If
                                        solid(X1 + 7 - x) = True
                                    'End If
                                End If
                            Next x
                        End If
                    Else
                    '#End If
                        If attr And 64 Then 'horizontal flip
                            Aa = i + X1
                            For x = 0 To 7 'draw yellow block for now.
                                If Byte1 And pow2(x) Then Color = 1 Else Color = 0
                                If Byte2 And pow2(x) Then Color = Color + 2
                                If Color Then
                                    If Not solid(X1 + x) Then
                                        If ontop Then
                                            vBuffer(Aa + x) = addToCol Or Color
                                        ElseIf (vBuffer(Aa + x) And 3) = 0 Then
                                            vBuffer(Aa + x) = addToCol Or Color
                                        End If
                                        solid(X1 + x) = True
                                    End If
                                End If
                            Next x
                        Else
                            Aa = i + X1 + 7
                            For x = 7 To 0 Step -1 'draw yellow block for now.
                                If Byte1 And pow2(x) Then Color = 1 Else Color = 0
                                If Byte2 And pow2(x) Then Color = Color + 2
                                If Color Then
                                    If Not solid(X1 + 7 - x) Then
                                        If ontop Then
                                            vBuffer(Aa - x) = addToCol Or Color
                                        ElseIf (vBuffer(Aa - x) And 3) = 0 Then
                                            vBuffer(Aa - x) = addToCol Or Color
                                        End If
                                        solid(X1 + 7 - x) = True
                                    End If
                                End If
                            Next x
                        End If
                    End If
                End If
                'force sprite 0 detection for those games with background glitches
                'otherwise, some crash
                If spr = 0 Then If Scanline = y1 + h - 1 Then PPU_Status = PPU_Status Or &H40 'claim we hit sprite #0
            End If
        'End If
    End If
Next spr
End Sub

Public Sub domirror()
  If Mirroring = 3 Then
     MirrorXor = 3333
  Else
     MirrorXor = (((Mirroring + 1) Mod 3) * &H400&)
  End If
  Select Case Mirroring
    Case 0
      mirror(0) = 0
      mirror(1) = 0
      mirror(2) = 1
      mirror(3) = 1
    Case 1
      mirror(0) = 0
      mirror(1) = 1
      mirror(2) = 0
      mirror(3) = 1
    Case 2
      mirror(0) = 0
      mirror(1) = 0
      mirror(2) = 0
      mirror(3) = 0
    Case 3
      mirror(0) = 1
      mirror(1) = 1
      mirror(2) = 1
      mirror(3) = 1
    Case 4
      mirror(0) = 0
      mirror(1) = 1
      mirror(2) = 2
      mirror(3) = 3
  End Select
End Sub

Public Function Read6502(ByVal Address As Long) As Byte
Dim tmp As Byte
    ' Rewritten 29.03.02
    Select Case Address
        Case &H0 To &H1FFF&: Read6502 = bank0(Address And &H7FF&) ' NES ram 0-7ff mirrored at 800 1000 1800
        Case &H2000& To &H3FFF&
            Select Case (Address And &H7&)
                Case &H0&: Read6502 = ppuLatch
                Case &H1&: Read6502 = ppuLatch
                Case &H2&
                    Dim ret As Byte
                    ScrollToggle = 0
                    PPU_AddressIsHi = True
                    ret = (ppuLatch And &H1F) Or PPU_Status
                    If (ret And &H80) Then PPU_Status = (PPU_Status And &H60)
                    Read6502 = ret
                Case &H4&
                    tmp = ppuLatch
                    ppuLatch = SpriteRAM(SpriteAddress)
                    SpriteAddress = (SpriteAddress + 1) And &HFF
                    Read6502 = tmp
                Case &H5&: Read6502 = ppuLatch
                Case &H6&: Read6502 = ppuLatch
                Case &H7&
                    tmp = ppuLatch
                    If Mapper = 9 Then
                        If PPUAddress < &H2000& Then
                            map9_latch tmp, (PPUAddress And &H1000&)
                        End If
                    End If
                    If PPUAddress >= &H2000& And PPUAddress <= &H2FFF& Then
                        ppuLatch = nt(mirror((PPUAddress And &HC00&) \ &H400&), PPUAddress And &H3FF&)
                    Else
                        ppuLatch = VRAM(PPUAddress And &H3FFF&)
                    End If
                    If (PPU_Control1 And &H4) Then
                        PPUAddress = PPUAddress + 32
                    Else
                        PPUAddress = PPUAddress + 1
                    End If
                    PPUAddress = (PPUAddress And &H3FFF&)
                    Read6502 = tmp
            End Select
        Case &H4000& To &H4013&, &H4015&
            Read6502 = Sound(Address - &H4000&)
        Case &H4016& ' Joypad1
            Read6502 = Joypad1(Joypad1_Count)
            Joypad1_Count = (Joypad1_Count + 1) And 7
        Case &H4017& ' Joypad2
            Read6502 = Joypad2(Joypad2_Count)
            Joypad2_Count = (Joypad2_Count + 1) And 7
        Case &H6000& To &H7FFF&: Read6502 = bank6(Address And &H1FFF&)
        Case &H8000& To &H9FFF&: Read6502 = bank8(Address And &H1FFF&)
        Case &HA000& To &HBFFF&: Read6502 = bankA(Address And &H1FFF&)
        Case &HC000& To &HDFFF&: Read6502 = bankC(Address And &H1FFF&)
        Case &HE000& To &HFFFF&: Read6502 = bankE(Address And &H1FFF&)
    End Select
End Function
Public Sub Write6502(ByVal Address As Long, ByVal value As Byte)
    ' Rewritten 29.03.02
    If Address >= &H2000& And Address <= &H3FFF& Then ppuLatch = value
    Select Case Address
        Case &H0& To &H1FFF&: bank0(Address And &H7FF&) = value
        Case &H2000& To &H3FFF&
            Select Case (Address And &H7)
                Case &H0&
                    PPU_Control1 = value
                    PPUAddress2 = (PPUAddress2 And &HF3FF&) Or (value And 3) * &H400&
                Case &H1&: PPU_Control2 = value
                Case &H2&: ppuLatch = value
                Case &H3&: SpriteAddress = value
                Case &H4&
                    SpriteRAM(SpriteAddress) = value
                    SpriteAddress = (SpriteAddress + 1) And &HFF
                    SpritesChanged = True
                Case &H5&
                    If PPU_AddressIsHi Then
                        HScroll2 = value And 7
                        PPUAddress2 = (PPUAddress2 And &HFFE0&) Or value \ 8

                        PPU_AddressIsHi = False
                    Else
                        PPUAddress2 = (PPUAddress2 And &H8C1F&) Or (value And &HF8) * 4 Or (value And 7) * &H1000&

                        PPU_AddressIsHi = True
                    End If
                Case &H6&
                    If PPU_AddressIsHi Then
                        PPUAddress = (PPUAddress And &HFF) Or ((value And &H3F) * &H100&)
                        PPU_AddressIsHi = False
                    Else
                        PPUAddress = (PPUAddress And &H7F00&) Or value
                        PPU_AddressIsHi = True
                    End If

                Case &H7&
                    ppuLatch = value
                    If Mapper = 9 Then
                        If PPUAddress <= &H1FFF& And PPUAddress >= &H0& Then
                            map9_latch value, (PPUAddress And &H1000&)
                        End If
                    End If
                    If PPUAddress >= &H2000& And PPUAddress <= &H2FFF& Then
                        nt(mirror((PPUAddress And &HC00&) \ &H400&), PPUAddress And &H3FF&) = value
                    Else
                        VRAM(PPUAddress) = value
                        If (PPUAddress And &HFFEF&) = &H3F00& Then
                            VRAM(PPUAddress Xor 16) = value
                        End If
                    End If
                    If (PPU_Control1 And &H4) Then
                        PPUAddress = (PPUAddress + 32)
                    Else
                        PPUAddress = (PPUAddress + 1)
                    End If
                    PPU_AddressIsHi = True
                    PPUAddress = (PPUAddress And &H3FFF&)
            End Select
        Case &H4000& To &H4013&
            Sound(Address - &H4000&) = value
            Dim n
            n = (Address - &H4000&) \ 4
            If n < 4 Then ChannelWrite(n) = True
        Case &H4014&
            MemCopy SpriteRAM(0), bank0(value * &H100&), &HFF
            SpritesChanged = True
        Case &H4015&: SoundCtrl = value
        Case &H6000& To &H7FFF&
            If SpecialWrite6000 Then
                mapperwrite Address, value
            Else
                bank6(Address And &H1FFF&) = value
            End If
        Case &H8000& To &HFFFF&: mapperwrite Address, value
    End Select
End Sub
Public Function LoadNES(ByVal filename As String) As Byte
On Error Resume Next
tmpLatch = 0
'===================================='
'           LoadNES(filename)        '
' Used to Load the NES ROM/VROM to   '
' specified arrays, gameImage and    '
' VROM, then figures out what to do  '
' based on the mapper number.        '
'===================================='
Dim Header As String * 3
Dim FileNum As Integer, choseit As Byte
FileNum = FreeFile

Dim i As Long
Dim ROMCtrl As Byte, ROMCtrl2 As Byte
Erase VRAM: Erase VROM: Erase gameImage: Erase bank8: Erase bankA
Erase bankC: Erase bankE: Erase bank0: Erase bank6
SpecialWrite6000 = False

If Dir$(filename) = "" Then LoadNES = 0: Exit Function

Close #1

PrgCount = 0: PrgCount2 = 0: ChrCount = 0: ChrCount2 = 0

Open filename For Binary As #FileNum
    Get #FileNum, , Header
    If Header <> "NES" And IgnoreNESErrHeader = "0" Then
       LoadNES = 0
       Close #FileNum
       MsgBox "Invalid NES Header." & vbCrLf & vbCrLf & "If you still want to load thet rom,please check 'Options->Ignore Error Header's NES File ' to skip this error." & vbCrLf & _
vbCrLf & "***WARNING***" & vbCrLf & "THERE MAY CONTAIN MANY CRITICAL ERROR !!!", vbCritical, "Error"
       frmNES.ConsoleText.Text = "invalid nes header." & vbCrLf & frmNES.ConsoleText.Text
       Exit Function
    End If
    
    Get #FileNum, 5, PrgCount: PrgCount2 = PrgCount
    Get #FileNum, 6, ChrCount: ChrCount2 = ChrCount
    Get #FileNum, 7, ROMCtrl
    Get #FileNum, 8, ROMCtrl2
    
    Mapper = CByte("&H" & Left$(fixhex(Hex(ROMCtrl2)), 1) & Left$(fixhex(Hex(ROMCtrl)), 1))

    Trainer = ROMCtrl And &H4
    Mirroring = ROMCtrl And &H1
    FourScreen = ROMCtrl And &H8
    If ROMCtrl And &H2 Then UsesSRAM = True
    Dim PrgMark As Long
    PrgMark = (PrgCount2 * &H4000&) - 1
    'Mirroring=1 is vertical
    If Trainer Then
        Get #FileNum, 17, Train
        'MemCopy bank6(&H1000&), Train(0), &H200
    End If
    
    ReDim gameImage(PrgMark) As Byte
    Dim startat As Integer
    If Trainer Then startat = 529 Else startat = 17
    Get #FileNum, startat, gameImage

    ReDim VROM(ChrCount2 * &H2000&) As Byte
    PrgMark = &H4000& * PrgCount2 + startat
    If ChrCount2 Then
        Get #FileNum, PrgMark, VROM
    End If
    MMC_Reset
    
    Select Case Mapper
    Case 0, 2, 22, 32, 33, 73, 99, 130, 188, 232
      If ChrCount Then Call Select8KVROM(0)
      reg8 = 0
      regA = 1
      regC = &HFE
      regE = &HFF
      Call SetupBanks
    Case 1, 185
      Call Select8KVROM(0)
      reg8 = 0
      regA = 1
      regC = &HFE
      regE = &HFF
      Call SetupBanks
      sequence = 0
      accumulator = 0
      Erase data
      data(0) = &H1F
      data(3) = 0
    Case 3, 78
      reg8 = 0
      regA = 1
      regC = PrgCount * 2 - 2
      regE = PrgCount * 2 - 1
      Call SetupBanks
      If ChrCount Then Select8KVROM (0)
    Case 4, 12, 64, 74, 95, 115, 118, 151, 158, 245, 250
      swap = False
      reg8 = 0
      regA = 1
      regC = &HFE
      regE = &HFF
      Call map4_sync
      MMC3_IrqVal = 0
      MMC3_IrqOn = False
      MMC3_TmpVal = 0
      If ChrCount Then Call Select8KVROM(0)
    Case 6
      reg8 = &H0
      regA = &H1
      regC = &H7
      regE = &H8
      Call SetupBanks
      If ChrCount Then Call Select8KVROM(0)
    Case 7, 51, 53, 226
      reg8 = 0
      regA = 1
      regC = 2
      regE = 3
      Call SetupBanks
    Case 8
      reg8 = 0
      regA = 1
      regC = 2
      regE = 3
      Call SetupBanks
      Call Select8KVROM(0)
    Case 9, 10
      reg8 = 0
      regA = &HFD
      regC = &HFE
      regE = &HFF
      Call SetupBanks
      latch1 = &HFE
      latch2 = &HFE
      Call Select8KVROM(0)
    Case 11, 46, 201, 234
      reg8 = 0
      regA = 1
      regC = 2
      regE = 3
      Call SetupBanks
      Call Select8KVROM(0)
    Case 13, 41
      reg8 = 0
      regA = 1
      regC = 2
      regE = 3
      Call SetupBanks
      Call Select4KVROM(0, 0)
      Call Select4KVROM(0, 1)
      latch13 = 0
    Case 15
      reg8 = 0
      regA = 1
      regC = 2
      regE = 3
      Call SetupBanks
    Case 16
      reg8 = 0
      regA = 1
      regC = &HFE
      regE = &HFF
      Call SetupBanks
      MMC16_Irq = 0
      MMC16_IrqOn = 0
      SpecialWrite6000 = True
    Case 17
      reg8 = 0
      regA = 1
      regC = &HFE
      regE = &HFF
      Call SetupBanks
      map17_irq = 0
      map17_irqon = False
    Case 19, 79, 86, 87, 113, 184
      reg8 = 0
      regA = 1
      regC = &HFE
      regE = &HFF
      Call SetupBanks
      Call Select8KVROM(ChrCount - 1)
    Case 23
      swap = False
      reg8 = 0
      regA = 1
      regC = &HFE
      regE = &HFF
      Call map4_sync
      Erase map23_hichr, map23_lochr
      map23_IRQEnabled = 0
      map23_IRQLatch = 0
      map23_IRQLatchLo = 0
      map23_IRQLatchHi = 0
      map23_IRQCounter = 0
      map23_IRQEnOnWrite = 0
      If ChrCount Then Call Select8KVROM(0)
    Case 24, 26
      reg8 = 0
      regA = 1
      regC = &HFE
      regE = &HFF
      Call SetupBanks
      map24_IRQCounter = 0
      map24_IRQEnabled = 0
      map24_IRQLatch = 0
      map24_IRQEnOnWrite = 0
    Case 34
      SpecialWrite6000 = True
      reg8 = 0
      regA = 1
      regC = 2
      regE = 3
      Call SetupBanks
      If ChrCount Then
        Call Select8KVROM(0)
      End If
    Case 40, 61, 200, 231
      choseit = 6
      choseit = MaskBankAddress(choseit)
      UsesSRAM = True
      Call MemCopy(bank6(0), gameImage(choseit * &H2000&), &H2000&)
      reg8 = &HFC
      regA = &HFD
      regC = &HFE
      regE = &HFF
      Call SetupBanks
      Call Select8KVROM(0)
      Mapper40_IRQEnabled = 0
      Mapper40_IRQCounter = 0
    Case 57
      MMC_Reg(0) = 0
      reg8 = 0
      regA = 1
      regC = 0
      regE = 1
      Call SetupBanks
      Call Select8KVROM(0)
    Case 65
      reg8 = 0
      regA = 1
      regC = &HFE
      regE = &HFF
      Call SetupBanks
    Case 66, 107, 229, 255
      reg8 = 0
      regA = 1
      regC = 2
      regE = 3
      Call SetupBanks
      Call Select8KVROM(0)
      Call SetupBanks
    Case 68
      reg8 = 0
      regA = 1
      regC = &HFE
      regE = &HFF
      Call Select8KVROM(0)
      Call SetupBanks
      UsesSRAM = True
    Case 69
      reg8 = 0
      regA = 1
      regC = 2
      regE = &HFF
      Call SetupBanks
      Call Select8KVROM(0)
    Case 71
      reg8 = 0
      regA = 1
      regC = &HFE
      regE = &HFF
      Call SetupBanks
    Case 75
      reg8 = 0
      regA = 1
      regC = PrgCount * 2 - 2
      regE = PrgCount * 2 - 1
      SetupBanks
      If ChrCount Then Select8KVROM 0
      MMC_Prg(0) = 0
      MMC_Prg(1) = 1
    Case 79
      reg8 = 0
      regA = 1
      regC = 2
      regE = 3
      SpecialWrite6000 = True
      Call SetupBanks
      If ChrCount Then Call Select8KVROM(0)
    Case 85
      reg8 = 0
      regA = 1
      regC = &HFE
      regE = &HFF
      Call SetupBanks
      map85_IRQCounter = 0
      map85_IRQEnabled = 0
      map85_IRQLatch = 0
      map85_IRQEnOnWrite = 0
    Case 90, 160
      reg8 = &HFC
      regA = &HFD
      regC = &HFE
      regE = &HFF
      Call SetupBanks
    Case 91
      SpecialWrite6000 = True
      reg8 = &HFE
      regA = &HFF
      regC = &HFE
      regE = &HFF
      Call Select8KVROM(0)
      Call SetupBanks
    Case 94
      reg8 = 0
      regA = 1
      regC = PrgCount * 2 - 2
      regE = PrgCount * 2 - 1
      Call SetupBanks
    Case Else
      Call MsgBox("mapper #" & Mapper & " is not supported.", vbCritical)
      frmNES.ConsoleText.Text = "mapper " & Mapper & " not supported." & vbCrLf & frmNES.ConsoleText.Text
      Erase gameImage, VROM
      Close #FileNum
      LoadNES = 0
      Exit Function
    End Select
    Call reset6502
    If Mirroring = 1 Then
      MirrorXor = &H800&
    Else
      MirrorXor = &H400&
    End If
    If FourScreen Then
      Mirroring = 4
    End If
    Call domirror
    
    Close #FileNum

CurrentLine = 0
For i = 0 To 7
    Joypad1(i) = &H40
Next i

FileNum = FreeFile
If UsesSRAM = True Then ' save the SRAM to a file.
    If Dir(App.Path & "\folders\srams\" & romName & ".srm") <> "" Then
        Open App.Path & "\folders\srams\" & romName & ".srm" For Binary Access Read As #FileNum
            Get #FileNum, , bank6
        Close #FileNum
    End If
End If

Frames = 0
CPUPaused = False
ScrollToggle = 1
frmNES.mnuFileFree.Enabled = True
LoadNES = 1
End Function

Public Sub LoadPal()
  Dim n As Long, zz As Long, r As Byte, g As Byte, b As Byte, FileNum As Integer
  n = 0
  zz = 0
  PALFile(0) = &H6D: PALFile(1) = &H6D: PALFile(2) = &H6D
  PALFile(3) = &H1: PALFile(4) = &H28: PALFile(5) = &HA9
  PALFile(6) = &H17: PALFile(7) = &H11: PALFile(8) = &HB0
  PALFile(9) = &H54: PALFile(10) = &H7: PALFile(11) = &HAB
  PALFile(12) = &H84: PALFile(13) = &H1: PALFile(14) = &H7B
  PALFile(15) = &H8A: PALFile(16) = &H3: PALFile(17) = &H2D
  PALFile(18) = &H82: PALFile(19) = &H9: PALFile(20) = &H4
  PALFile(21) = &H67: PALFile(22) = &H21: PALFile(23) = &H0
  PALFile(24) = &H36: PALFile(25) = &H38: PALFile(26) = &H0
  PALFile(27) = &H1B: PALFile(28) = &H51: PALFile(29) = &H3
  PALFile(30) = &H0: PALFile(31) = &H6C: PALFile(32) = &H1
  PALFile(33) = &H0: PALFile(34) = &H59: PALFile(35) = &H36
  PALFile(36) = &H0: PALFile(37) = &H49: PALFile(38) = &H72
  PALFile(39) = &H0: PALFile(40) = &H0: PALFile(41) = &H0
  PALFile(42) = &H5: PALFile(43) = &H5: PALFile(44) = &H5
  PALFile(45) = &H5: PALFile(46) = &H5: PALFile(47) = &H5
  PALFile(48) = &HCB: PALFile(49) = &HC5: PALFile(50) = &HBF
  PALFile(51) = &H1D: PALFile(52) = &H5D: PALFile(53) = &HE6
  PALFile(54) = &H43: PALFile(55) = &H34: PALFile(56) = &HEE
  PALFile(57) = &H88: PALFile(58) = &H36: PALFile(59) = &HF1
  PALFile(60) = &HBE: PALFile(61) = &HF: PALFile(62) = &HC4
  PALFile(63) = &HDD: PALFile(64) = &H1A: PALFile(65) = &H70
  PALFile(66) = &HD1: PALFile(67) = &H28: PALFile(68) = &H1D
  PALFile(69) = &HAE: PALFile(70) = &H51: PALFile(71) = &HB
  PALFile(72) = &H6F: PALFile(73) = &H6C: PALFile(74) = &H0
  PALFile(75) = &H30: PALFile(76) = &H87: PALFile(77) = &H0
  PALFile(78) = &H1: PALFile(79) = &HA2: PALFile(80) = &HF
  PALFile(81) = &H0: PALFile(82) = &H90: PALFile(83) = &H55
  PALFile(84) = &H0: PALFile(85) = &H81: PALFile(86) = &HA5
  PALFile(87) = &H19: PALFile(88) = &H19: PALFile(89) = &H19
  PALFile(90) = &H5: PALFile(91) = &H5: PALFile(92) = &H5
  PALFile(93) = &H5: PALFile(94) = &H5: PALFile(95) = &H5
  PALFile(96) = &HFC: PALFile(97) = &HFC: PALFile(98) = &HFC
  PALFile(99) = &H5A: PALFile(100) = &HB1: PALFile(101) = &HFE
  PALFile(102) = &H96: PALFile(103) = &H8A: PALFile(104) = &HFE
  PALFile(105) = &HD4: PALFile(106) = &H70: PALFile(107) = &HFE
  PALFile(108) = &HFA: PALFile(109) = &H5D: PALFile(110) = &HFE
  PALFile(111) = &HFE: PALFile(112) = &H63: PALFile(113) = &HC8
  PALFile(114) = &HFE: PALFile(115) = &H79: PALFile(116) = &H6A
  PALFile(117) = &HFA: PALFile(118) = &H9A: PALFile(119) = &H32
  PALFile(120) = &HDC: PALFile(121) = &HCA: PALFile(122) = &H13
  PALFile(123) = &H83: PALFile(124) = &HDC: PALFile(125) = &H27
  PALFile(126) = &H42: PALFile(127) = &HEC: PALFile(128) = &H42
  PALFile(129) = &H35: PALFile(130) = &HD4: PALFile(131) = &H97
  PALFile(132) = &H2F: PALFile(133) = &HD8: PALFile(134) = &HE7
  PALFile(135) = &H6D: PALFile(136) = &H6D: PALFile(137) = &H6D
  PALFile(138) = &H5: PALFile(139) = &H5: PALFile(140) = &H5
  PALFile(141) = &H5: PALFile(142) = &H5: PALFile(143) = &H5
  PALFile(144) = &HFE: PALFile(145) = &HFE: PALFile(146) = &HFE
  PALFile(147) = &HB7: PALFile(148) = &HEA: PALFile(149) = &HFE
  PALFile(150) = &HCF: PALFile(151) = &HC6: PALFile(152) = &HFC
  PALFile(153) = &HEC: PALFile(154) = &HB9: PALFile(155) = &HFC
  PALFile(156) = &HFE: PALFile(157) = &HB1: PALFile(158) = &HFE
  PALFile(159) = &HFE: PALFile(160) = &HB9: PALFile(161) = &HF2
  PALFile(162) = &HFE: PALFile(163) = &HC6: PALFile(164) = &HC1
  PALFile(165) = &HFE: PALFile(166) = &HD9: PALFile(167) = &H9B
  PALFile(168) = &HF5: PALFile(169) = &HF0: PALFile(170) = &H86
  PALFile(171) = &HD0: PALFile(172) = &HF8: PALFile(173) = &H8E
  PALFile(174) = &HA7: PALFile(175) = &HF8: PALFile(176) = &HB5
  PALFile(177) = &H99: PALFile(178) = &HF5: PALFile(179) = &HEA
  PALFile(180) = &H9E: PALFile(181) = &HF6: PALFile(182) = &HFE
  PALFile(183) = &HD5: PALFile(184) = &HCA: PALFile(185) = &HD5
  PALFile(186) = &H5: PALFile(187) = &H5: PALFile(188) = &H5
  PALFile(189) = &H5: PALFile(190) = &H5: PALFile(191) = &H5
  Do
    r = CByte(PALFile(zz))
    g = CByte(PALFile(zz + 1))
    b = CByte(PALFile(zz + 2))
    pal(n) = RGB2(r, g, b)
    pal16(n) = rgb16(r, g, b)
    pal15(n) = rgb15(r, g, b)
    pal(n + 64) = pal(n)
    pal(n + 128) = pal(n)
    pal(n + 192) = pal(n)
    pal16(n + 64) = pal16(n)
    pal16(n + 128) = pal16(n)
    pal16(n + 192) = pal16(n)
    pal15(n + 64) = pal15(n)
    pal15(n + 128) = pal15(n)
    pal15(n + 192) = pal15(n)
    n = n + 1
    zz = zz + 3
  Loop Until n = 64
End Sub

'DF: had to reverse colors in palette for it to look right with new gfx.
'later changed for 16bit color, then back to 32bit
Function RGB2(ByVal b As Long, ByVal g As Long, ByVal r As Long) As Long
RGB2 = RGB(r, g, b)
End Function
Function rgb16(ByVal b As Long, ByVal g As Long, ByVal r As Long) As Long
    Dim c As Long
    c = (r \ 8) + (g \ 4) * 32 + (b \ 8) * 2048
    If c > 32767 Then c = c - 65536
    rgb16 = c
End Function
Function rgb15(ByVal b As Long, ByVal g As Long, ByVal r As Long) As Long
    rgb15 = (r \ 8) + (g \ 8) * 32 + (b \ 8) * 1024
End Function

Public Sub mmc_irq(firstirqs As Long)
  If firstirqs = &H1 Then
    Select Case Mapper
      Case 4, 118, 115, 95, 151, 12, 64, 158, 74, 245: Call map4_hblank(CurrentLine, PPU_Control2)
      Case 6: Call map6_hblank(CurrentLine)
      Case 16: Call map16_irq
      Case 17: Call map17_doirq
      Case 19, 184, 87, 86, 113, 79: Call map19_irq
      Case 23: Call map23_irq
      Case 24, 26: Call map24_irq
      Case 85: Call map85_irq
    End Select
  Else
    Select Case Mapper
      Case 40, 61, 200, 231: Call map40_irq
    End Select
  End If
End Sub

Public Sub ppuleftclip(colordepth)
  Dim i As Long
  If ClippingLatch = True Then
    For i = 0 To UBound(vBuffer16) Step 256
      Select Case colordepth
        Case 15, 16
          vBuffer16(i) = p16(0)
          vBuffer16(i + 1) = p16(0)
          vBuffer16(i + 2) = p16(0)
          vBuffer16(i + 3) = p16(0)
          vBuffer16(i + 4) = p16(0)
          vBuffer16(i + 5) = p16(0)
          vBuffer16(i + 6) = p16(0)
          vBuffer16(i + 7) = p16(0)
          vBuffer16(i + 248) = p16(0)
          vBuffer16(i + 249) = p16(0)
          vBuffer16(i + 250) = p16(0)
          vBuffer16(i + 251) = p16(0)
          vBuffer16(i + 252) = p16(0)
          vBuffer16(i + 253) = p16(0)
          vBuffer16(i + 254) = p16(0)
          vBuffer16(i + 255) = p16(0)
        Case 32
          vBuffer32(i) = p32(0)
          vBuffer32(i + 1) = p32(0)
          vBuffer32(i + 2) = p32(0)
          vBuffer32(i + 3) = p32(0)
          vBuffer32(i + 4) = p32(0)
          vBuffer32(i + 5) = p32(0)
          vBuffer32(i + 6) = p32(0)
          vBuffer32(i + 7) = p32(0)
          vBuffer32(i + 248) = p32(0)
          vBuffer32(i + 249) = p32(0)
          vBuffer32(i + 250) = p32(0)
          vBuffer32(i + 251) = p32(0)
          vBuffer32(i + 252) = p32(0)
          vBuffer32(i + 253) = p32(0)
          vBuffer32(i + 254) = p32(0)
          vBuffer32(i + 255) = p32(0)
      End Select
    Next i
  End If
End Sub

Public Sub mapperwrite(ByVal Address As Long, ByVal value As Byte)
  Select Case Mapper
    Case 1, 185: Call map1_write(Address, value)
    Case 2, 73, 130, 188, 232: Call map2_write(Address, value)
    Case 3: Call map3_write(Address, value)
    Case 4, 118, 115, 95, 151, 12, 64, 158, 74, 245: Call map4_write(Address, value)
    Case 6: Call map6_write(Address, value)
    Case 7, 51, 53, 226: Call map7_write(Address, value)
    Case 8, 66, 107, 229, 255: Call map66_write(Address, value)
    Case 9, 10: Call map9_write(Address, value)
    Case 11, 234, 201, 46: Call map11_write(Address, value)
    Case 13, 41: Call map13_write(Address, value)
    Case 15: Call map15_write(Address, value)
    Case 16: Call map16_write(Address, value)
    Case 17: Call map17_write(Address, value)
    Case 19, 184, 87, 86, 113, 79: Call map19_write(Address, value)
    Case 22: Call map22_write(Address, value)
    Case 23: Call map23_write(Address, value)
    Case 24, 26: Call map24_write(Address, value)
    Case 57: Call map57_write(Address, value)
    Case 85: Call map85_write(Address, value)
    Case 32: Call map32_write(Address, value)
    Case 33: Call map33_write(Address, value)
    Case 34: Call map34_write(Address, value)
    Case 40, 61, 200, 231: Call map40_write(Address, value)
    Case 65: Call map65_write(Address, value)
    Case 68: Call map68_write(Address, value)
    Case 69: Call map69_write(Address, value)
    Case 71: Call map71_write(Address, value)
    Case 75: Call map75_write(Address, value)
    Case 78: Call map78_write(Address, value)
    Case 79: Call map79_write(Address, value)
    Case 90, 160: Call map90_write(Address, value)
    Case 91: Call map91_write(Address, value)
    Case 94: Call map94_write(Address, value)
    Case 250: Call map250_write(Address, value)
  End Select
End Sub
