Attribute VB_Name = "mapper23"
Option Explicit

Public map23_hichr(7) As Byte

Public map23_lochr(7) As Byte

Public map23_IRQEnabled As Byte

Public map23_IRQLatch As Byte

Public map23_IRQLatchLo As Byte

Public map23_IRQLatchHi As Byte

Public map23_IRQCounter As Byte

Public map23_IRQEnOnWrite As Byte

Public Sub map23_write(Address As Long, value As Byte)
  Dim page As Byte
  Address = ((Address / 4) And 3) Or Address
  Address = Address And &HF003
  Select Case Address
    Case &H8000& To &H800F&
      PrgSwitch1 = value
      Call map4_sync
    Case &H9000& To &H9001&
      Mirroring = (value And &H3)
      If Mirroring = 1 Then
        Mirroring = 0
      ElseIf Mirroring = 0 Then
        Mirroring = 1
      End If
      Call DoMirror
    Case &H9002& To &H9003&
      If (value And &H2) Then
        swap = True
      Else
        swap = False
      End If
      Call map4_sync
    Case &HA000& To &HA00F&
      PrgSwitch2 = value
      Call map4_sync
    Case &HB000&
      map23_lochr(0) = value
      page = (map23_lochr(0) And &HF) + ((map23_hichr(0) And &HF) * 16)
      Call Select1KVROM(page, 0)
    Case &HB001&
      map23_hichr(0) = value
      page = (map23_lochr(0) And &HF) + ((map23_hichr(0) And &HF) * 16)
      Call Select1KVROM(page, 0)
    Case &HB002&
      map23_lochr(1) = value
      page = (map23_lochr(1) And &HF) + ((map23_hichr(1) And &HF) * 16)
      Call Select1KVROM(page, 1)
    Case &HB003&
      map23_hichr(1) = value
      page = (map23_lochr(1) And &HF) + ((map23_hichr(1) And &HF) * 16)
      Call Select1KVROM(page, 1)
    Case &HC000&
      map23_lochr(2) = value
      page = (map23_lochr(2) And &HF) + ((map23_hichr(2) And &HF) * 16)
      Call Select1KVROM(page, 2)
    Case &HC001&
      map23_hichr(2) = value
      page = (map23_lochr(2) And &HF) + ((map23_hichr(2) And &HF) * 16)
      Call Select1KVROM(page, 2)
    Case &HC002&
      map23_lochr(3) = value
      page = (map23_lochr(3) And &HF) + ((map23_hichr(3) And &HF) * 16)
      Call Select1KVROM(page, 3)
    Case &HC003&
      map23_hichr(3) = value
      page = (map23_lochr(3) And &HF) + ((map23_hichr(3) And &HF) * 16)
      Call Select1KVROM(page, 3)
    Case &HD000&
      map23_lochr(4) = value
      page = (map23_lochr(4) And &HF) + ((map23_hichr(4) And &HF) * 16)
      Call Select1KVROM(page, 4)
    Case &HD001&
      map23_hichr(4) = value
      page = (map23_lochr(4) And &HF) + ((map23_hichr(4) And &HF) * 16)
      Call Select1KVROM(page, 4)
    Case &HD002&
      map23_lochr(5) = value
      page = (map23_lochr(5) And &HF) + ((map23_hichr(5) And &HF) * 16)
      Call Select1KVROM(page, 5)
    Case &HD003&
      map23_hichr(5) = value
      page = (map23_lochr(5) And &HF) + ((map23_hichr(5) And &HF) * 16)
      Call Select1KVROM(page, 5)
    Case &HE000&
      map23_lochr(6) = value
      page = (map23_lochr(6) And &HF) + ((map23_hichr(6) And &HF) * 16)
      Call Select1KVROM(page, 6)
    Case &HE001&
      map23_hichr(6) = value
      page = (map23_lochr(6) And &HF) + ((map23_hichr(6) And &HF) * 16)
      Call Select1KVROM(page, 6)
    Case &HE002&
      map23_lochr(7) = value
      page = (map23_lochr(7) And &HF) + ((map23_hichr(7) And &HF) * 16)
      Call Select1KVROM(page, 7)
    Case &HE003&
      map23_hichr(7) = value
      page = (map23_lochr(7) And &HF) + ((map23_hichr(7) And &HF) * 16)
      Call Select1KVROM(page, 7)
    Case &HF000&
      map23_IRQLatchLo = value
      map23_IRQLatch = (map23_IRQLatchLo And &HF) + ((map23_IRQLatchHi And &HF) * 16)
    Case &HF001&
      map23_IRQLatchHi = value
      map23_IRQLatch = (map23_IRQLatchLo And &HF) + ((map23_IRQLatchHi And &HF) * 16)
    Case &HF002&
      map23_IRQEnabled = (value And &H2)
      map23_IRQEnOnWrite = (value And &H1)
      If (map23_IRQEnabled) Then
        map23_IRQCounter = map23_IRQLatch
      End If
    Case &HF003&
      map23_IRQEnabled = map23_IRQEnOnWrite
  End Select
End Sub

Public Sub map23_irq()
  If map23_IRQEnabled <> 0 Then
    If map23_IRQCounter = &HFF Then
      map23_IRQCounter = map23_IRQLatch
      Call irq6502
    Else
      map23_IRQCounter = map23_IRQCounter + 1
    End If
  End If
End Sub

