Attribute VB_Name = "mapper24"
Option Explicit

Public map24_IRQEnabled As Byte

Public map24_IRQLatch As Byte

Public map24_IRQCounter As Byte

Public map24_IRQEnOnWrite As Byte

Public Sub map24_write(Address As Long, value As Byte)
  If Mapper = 26 Then
    If (Address And &H3) = 1 Then
      Address = Address + 1
    ElseIf (Address And &H3) = 2 Then
      Address = Address - 1
    End If
  End If
  Select Case Address
    Case &H8000&
      reg8 = value * 2
      regA = reg8 + 1
      Call SetupBanks
    Case &HB003&
      Mirroring = ((value And &HC) \ &H4)
      If Mirroring = 0 Then
        Mirroring = 1
      ElseIf Mirroring = 1 Then
        Mirroring = 0
      End If
      Call DoMirror
    Case &HC000&
      regC = value
      Call SetupBanks
    Case &HD000& To &HD003&
      Call Select1KVROM(value, (Address And &H3))
    Case &HE000& To &HE003&
      Call Select1KVROM(value, (Address And &H3) + 4)
    Case &HF000&
      map24_IRQLatch = value
    Case &HF001&
      map24_IRQEnabled = (value And &H2)
      map24_IRQEnOnWrite = (value And &H1)
      If (map24_IRQEnabled) Then
        map24_IRQCounter = map24_IRQLatch
      End If
    Case &HF002&
      map24_IRQEnabled = map24_IRQEnOnWrite
  End Select
End Sub

Public Sub map24_irq()
  If map24_IRQEnabled <> 0 Then
    If map24_IRQCounter = &HFF Then
      map24_IRQCounter = map24_IRQLatch
      Call irq6502
    Else
      map24_IRQCounter = map24_IRQCounter + 1
    End If
  End If
End Sub

