Attribute VB_Name = "mapper74"
Option Explicit

Public Sub map74_sync()
  If swap Then
    reg8 = &HFE
    regA = PrgSwitch2
    regC = PrgSwitch1
    regE = &HFF
  Else
    reg8 = PrgSwitch1
    regA = PrgSwitch2
    regC = &HFE
    regE = &HFF
  End If
  Call setupbanks
End Sub

Public Function map74_hblank(Scanline, two As Byte) As Boolean
  If Scanline = 0 Then
    MMC3_IrqVal = MMC3_TmpVal
  ElseIf Scanline > 239 Then
    Exit Function
  ElseIf MMC3_IrqOn And (two And &H18) Then
    MMC3_IrqVal = (MMC3_IrqVal - 1) And &HFF
    If (MMC3_IrqVal = 0) Then
      Call irq6502
      MMC3_IrqVal = MMC3_TmpVal
    End If
  End If
End Function

Public Sub map74_write(Address As Long, value As Byte)
  Select Case Address
    Case &H8000&
      MMC3_Command = value And &H7
      If value And &H80 Then
        MMC3_ChrAddr = &H1000&
      Else
        MMC3_ChrAddr = 0
      End If
      If value And &H40 Then
        swap = 1
      Else
        swap = 0
      End If
    Case &H8001&
      Select Case MMC3_Command
        Case 0
          Call select1kvrom(value, 0)
          Call select1kvrom(value + 1, 1)
        Case 1
          Call select1kvrom(value, 2)
          Call select1kvrom(value + 1, 3)
        Case 2
          Call select1kvrom(value, 4)
        Case 3
          Call select1kvrom(value, 5)
        Case 4
          Call select1kvrom(value, 6)
        Case 5
          Call select1kvrom(value, 7)
        Case 6
          PrgSwitch1 = value
          Call map74_sync
        Case 7
          PrgSwitch2 = value
          Call map74_sync
      End Select
    Case &HA000&
      If value And 1 Then
        Mirroring = 0
      Else
        Mirroring = 1
      End If
      Call domirror
    Case &HA001&
      If value Then
        Usessram = True
      Else
        Usessram = False
      End If
    Case &HC000&
      MMC3_IrqVal = value
    Case &HC001&
      MMC3_TmpVal = value
    Case &HE000&
      MMC3_IrqOn = False
      MMC3_IrqVal = MMC3_TmpVal
    Case &HE001&
      MMC3_IrqOn = True
  End Select
End Sub

