Attribute VB_Name = "mapper85"
Option Explicit

Public map85_IRQEnabled As Byte

Public map85_IRQLatch As Byte

Public map85_IRQCounter As Byte

Public map85_IRQEnOnWrite As Byte

Public Sub map85_write(Address As Long, value As Byte)
  Select Case Address
    Case &H8000&
      reg8 = value
      Call SetupBanks
    Case &H8008&
      regA = value
      Call SetupBanks
    Case &H9000&
      regC = value
      Call SetupBanks
    Case &HE000&
      Mirroring = (value And &H3)
      If Mirroring = 0 Then
        Mirroring = 1
      ElseIf Mirroring = 1 Then
        Mirroring = 0
      End If
      Call domirror
    Case &HA000&
      Call Select1KVROM(value, 0)
    Case &HA008&
      Call Select1KVROM(value, 1)
    Case &HB000&
      Call Select1KVROM(value, 2)
    Case &HB008&
      Call Select1KVROM(value, 3)
    Case &HC000&
      Call Select1KVROM(value, 4)
    Case &HC008&
      Call Select1KVROM(value, 5)
    Case &HD000&
      Call Select1KVROM(value, 6)
    Case &HD008&
      Call Select1KVROM(value, 7)
    Case &HE008&
      map85_IRQLatch = value
    Case &HF000&
      map85_IRQEnabled = (value And &H2)
      map85_IRQEnOnWrite = (value And &H1)
      If (map85_IRQEnabled) Then
        map85_IRQCounter = map85_IRQLatch
      End If
    Case &HF008&
      map85_IRQEnabled = map85_IRQEnOnWrite
  End Select
End Sub

Public Sub map85_irq()
  If map85_IRQEnabled <> 0 Then
    If map85_IRQCounter = &HFF Then
      map85_IRQCounter = map85_IRQLatch
      Call irq6502
    Else
      map85_IRQCounter = map85_IRQCounter + 1
    End If
  End If
End Sub


